<?php
/**
 * PAYGENT B2B MODULE
 * PaymentResponseDataImpl.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleConnectException.php");
include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleException.php");
include_once("jp/co/ks/merchanttool/connectmodule/util/HttpsRequestSender.php");
include_once("jp/co/ks/merchanttool/connectmodule/util/StringUtil.php");
include_once("jp/co/ks/merchanttool/connectmodule/entity/ResponseData.php");

/**
 * όndNX
 * 
 * @version $Revision: 1.4 $
 * @author $Author: t-mori $
 */

	/**
	 * dp؂蕶
	 */
	define("PaymentResponseDataImpl__PROPERTIES_REGEX", "=");
	
	/**
	 * dp؂萔 
	 */
	define("PaymentResponseDataImpl__PROPERTIES_REGEX_COUNT", 2);
	
	/**
	 * s
	 */
	define("PaymentResponseDataImpl__LINE_SEPARATOR", "\r\n");


class PaymentResponseDataImpl extends ResponseData {

	/**  */
	var $resultStatus;

	/** X|XR[h */
	var $responseCode;

	/** X|Xڍ */
	var $responseDetail;

	/** f[^ array*/
	var $data;

	/** ݂Index */
	var $currentIndex;

	/**
	 * RXgN^
	 */
	function PaymentResponseDataImpl() {
		$this->data = array();
		$this->currentIndex = 0;
	}

	/**
	 * body 𕪉
	 * 
	 * @param X|X{fB
	 * @return boolean TRUE: AFG[R[h 
	 */
	function parse($body) {

		$line = "";
		// ێf[^
		$this->data = array();
		$map = array();

		// ݈ʒu
		$this->currentIndex = 0;
		
		// Ug̏
		$this->resultStatus = "";
		$this->responseCode = "";
		$this->responseDetail = "";
		
		// "_html" L[݃tO
		$htmlKeyFlg = false;
		
		// "_htmk" L[l
		$htmlKey = "";
		
		// "_html" L[oȌ̃f[^ێ
		$htmlValue = "";

		$lines = split(PaymentResponseDataImpl__LINE_SEPARATOR, $body);
		foreach($lines as $i => $line) {
			$lineItem = StringUtil::split($line, PaymentResponseDataImpl__PROPERTIES_REGEX, 
				PaymentResponseDataImpl__PROPERTIES_REGEX_COUNT);
			// ǍI
			$tmpLen = strlen($lineItem[0]) - strlen(ResponseData__HTML_ITEM);
			if ($tmpLen >= 0 
				&&  strpos($lineItem[0], ResponseData__HTML_ITEM, $tmpLen) 
				=== $tmpLen) {
				// Key  "_html" ̏ꍇ
				$htmlKey = $lineItem[0];
				$htmlKeyFlg = true;
			}
			if ($htmlKeyFlg) {
				if (!(strlen($lineItem[0]) - strlen(ResponseData__HTML_ITEM) >= 0 
					&& strpos($lineItem[0], ResponseData__HTML_ITEM,
						strlen($lineItem[0]) - strlen(ResponseData__HTML_ITEM)) 
					=== strlen($lineItem[0]) - strlen(ResponseData__HTML_ITEM))) {
					// "_html" Key ǂݎꂽꍇ
					$htmlValue .= $line;
					$htmlValue .= PaymentResponseDataImpl__LINE_SEPARATOR;
				}
			} else {
				if (0 < count($lineItem)) {
					if ($lineItem[0] == ResponseData__RESULT) {
						// ʂݒ
						$this->resultStatus = $lineItem[1];
					} else if ($lineItem[0] == ResponseData__RESPONSE_CODE) {
						// X|XR[hݒ
						$this->responseCode = $lineItem[1];
					} else if ($lineItem[0] == ResponseData__RESPONSE_DETAIL) {
						// X|Xڍׂݒ
						$this->responseDetail = $lineItem[1];
					} else {
						// Mapɐݒ
						$map[$lineItem[0]] = $lineItem[1];
					}
				}
			}
		}
		
		if ($htmlKeyFlg) {
			// "_html" Key oꍇAݒ
			if (strlen(PaymentResponseDataImpl__LINE_SEPARATOR) <= strlen($htmlValue)) {
				if (strpos($htmlValue, PaymentResponseDataImpl__LINE_SEPARATOR,
						strlen($htmlValue) - strlen(PaymentResponseDataImpl__LINE_SEPARATOR)) 
					=== strlen($htmlValue) - strlen(PaymentResponseDataImpl__LINE_SEPARATOR)) {
					$htmlValue = substr($htmlValue, 0, 
						strlen($htmlValue) - strlen(PaymentResponseDataImpl__LINE_SEPARATOR));
				}
			}
			$map[$htmlKey] = $htmlValue;
		}

		if (0 < count($map)) {
			// Map ݒ肳Ăꍇ
			$this->data[] = $map;
		}

		if (StringUtil::isEmpty($this->resultStatus)) {
			// ʂ 󕶎  null ̏ꍇ
			trigger_error(PaygentB2BModuleConnectException__KS_CONNECT_ERROR
			. ": resultStatus is Nothing.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
		}
		
		return true;
	}

	/**
	 * data 𕪉 Uĝ݁Aϐɔf
	 * 
	 * @param data
	 * @return boolean TRUE: AFALSEFs 
	 */
	function parseResultOnly($body) {

		$line = "";

		// ێf[^
		$this->data = array();

		// ݈ʒu
		$this->currentIndex = 0;
		
		// Ug̏
		$this->resultStatus = "";
		$this->responseCode = "";
		$this->responseDetail = "";

		$lines = split(PaymentResponseDataImpl__LINE_SEPARATOR, $body);
		foreach($lines as $i => $line) {
			$lineItem = StringUtil::split($line, PaymentResponseDataImpl__PROPERTIES_REGEX);
			// ǍI
			if (strpos($lineItem[0], ResponseData__HTML_ITEM) 
				=== strlen($lineItem[0]) - strlen(ResponseData__HTML_ITEM)) {
				// Key  "_html" ̏ꍇ
				break;
			}

			if (0 < count($lineItem)) {
				// 1sǍ(ڐ2ȏ̏ꍇ)
				if ($lineItem[0] == ResponseData__RESULT) {
					// ʂݒ
					$this->resultStatus = $lineItem[1];
				} else if ($lineItem[0] == ResponseData__RESPONSE_CODE) {
					// X|XR[hݒ
					$this->responseCode = $lineItem[1];
				} else if ($lineItem[0] == ResponseData__RESPONSE_DETAIL) {
					// X|Xڍׂݒ
					$this->responseDetail = $lineItem[1];
				}
			}
		}
		
		if (StringUtil::isEmpty($this->resultStatus)) {
			// ʂ 󕶎  null ̏ꍇ
			trigger_error(PaygentB2BModuleConnectException__KS_CONNECT_ERROR
				. ": resultStatus is Nothing.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
		}
		return true;
	}

	/**
	 * ̃f[^擾
	 * 
	 * @return Map f[^ȂꍇANULL߂
	 */
	function resNext() {
		$map = null;

		if ($this->hasResNext()) {

			$map =$this->data[$this->currentIndex];

			$this->currentIndex++;
		} 
		
		return $map;
	}

	/**
	 * ̃f[^݂邩
	 * 
	 * @return boolean true=݂ false=݂Ȃ
	 */
	function hasResNext() {
		$rb = false;

		if ($this->currentIndex < count($this->data)) {
			$rb = true;
		}

		return $rb;
	}

	/**
	 * resultStatus 擾
	 * 
	 * @return String
	 */
	function getResultStatus() {
		return $this->resultStatus;
	}

	/**
	 * responseCode 擾
	 * 
	 * @return String
	 */
	function getResponseCode() {
		return $this->responseCode;
	}

	/**
	 * responseDetail 擾
	 * 
	 * @return String
	 */
	function getResponseDetail() {
		return $this->responseDetail;
	}

}

?>