<?php
/**
 * PAYGENT B2B MODULE
 * ReferenceResponseDataImpl.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleConnectException.php");
include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleException.php");
include_once("jp/co/ks/merchanttool/connectmodule/util/CSVWriter.php");
include_once("jp/co/ks/merchanttool/connectmodule/util/CSVTokenizer.php");
include_once("jp/co/ks/merchanttool/connectmodule/util/HttpsRequestSender.php");
include_once("jp/co/ks/merchanttool/connectmodule/util/StringUtil.php");
include_once("jp/co/ks/merchanttool/connectmodule/entity/ResponseData.php");

/**
 * ƉndNX
 * 
 * @version $Revision: 1.4 $
 * @author $Author: t-mori $
 */


	/**
	 * sԍiwb_[j= "1"
	 */
	define("ReferenceResponseDataImpl__LINENO_HEADER", "1");

	/**
	 * sԍif[^wb_[j", "2"
	 */
	define("ReferenceResponseDataImpl__LINENO_DATA_HEADER", "2");

	/**
	 * sԍif[^j", "3"
	 */
	define("ReferenceResponseDataImpl__LINENO_DATA", "3");

	/**
	 * sԍig[[j", "4"
	 */
	define("ReferenceResponseDataImpl__LINENO_TRAILER", "4");

	/**
	 * R[h敪 ʒu", 0
	 */
	define("ReferenceResponseDataImpl__LINE_RECORD_DIVISION", 0);

	/**
	 * wb_[  ʒu 1
	 */
	define("ReferenceResponseDataImpl__LINE_HEADER_RESULT", 1);

	/**
	 * wb_[ X|XR[h ʒu", 2
	 */
	define("ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_CODE", 2);

	/**
	 * wb_[ X|Xڍ ʒu", 3
	 */
	define("ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_DETAIL", 3);

	/**
	 * g[[ f[^ ʒu", 1
	 */
	define("ReferenceResponseDataImpl__LINE_TRAILER_DATA_COUNT", 1);

	/**
	 * s
	 */
	define("ReferenceResponseDataImpl__LINE_SEPARATOR", "\r\n");

class ReferenceResponseDataImpl extends ResponseData {
	/**  */
	var $resultStatus;

	/** X|XR[h */
	var $responseCode;

	/** X|Xڍ */
	var $responseDetail;

	/** f[^wb_[ */
	var $dataHeader;

	/** f[^ */
	var $data;

	/** ݂Index */
	var $currentIndex;

	/**
	 * RXgN^
	 */
	function ReferenceResponseDataImpl() {
		$this->dataHeader = array();
		$this->data = array();
		$this->currentIndex = 0;
	}

	/**
	 * data 𕪉
	 * 
	 * @param data
	 * @return mixed TRUE:AFG[R[h 
	 */
	function parse($body) {

		$csvTknzr = new CSVTokenizer(CSVTokenizer__DEF_SEPARATOR, 
			CSVTokenizer__DEF_ITEM_ENVELOPE);

		// ێf[^
		$this->data = array();

		// ݈ʒu
		$this->currentIndex = 0;
		
		// Ug̏
		$this->resultStatus = "";
		$this->responseCode = "";
		$this->responseDetail = "";

		$lines = split(ReferenceResponseDataImpl__LINE_SEPARATOR, $body);
		foreach($lines as $i => $line) {
			$lineItem = $csvTknzr->parseCSVData($line);

			if (0 < count($lineItem)) {
				if ($lineItem[ReferenceResponseDataImpl__LINE_RECORD_DIVISION]
						== ReferenceResponseDataImpl__LINENO_HEADER) {
					// wb_[̍s̏ꍇ
					if (ReferenceResponseDataImpl__LINE_HEADER_RESULT < count($lineItem)) {
						// ʂݒ
						$this->resultStatus = $lineItem[ReferenceResponseDataImpl__LINE_HEADER_RESULT];
					}
					if (ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_CODE < count($lineItem)) {
						// X|XR[hݒ
						$this->responseCode = $lineItem[ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_CODE];
					}
					if (ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_DETAIL < count($lineItem)) {
						// X|Xڍׂݒ
						$this->responseDetail = $lineItem[ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_DETAIL];
					}
				} else if ($lineItem[ReferenceResponseDataImpl__LINE_RECORD_DIVISION]
						== ReferenceResponseDataImpl__LINENO_DATA_HEADER) {
					// f[^wb_[̍s̏ꍇ
					$this->dataHeader = array();

					for ($i = 1; $i < count($lineItem); $i++) {
						// f[^wb_[ݒiR[h敪͏j
						$this->dataHeader[] = $lineItem[$i];
					}
				} else if ($lineItem[ReferenceResponseDataImpl__LINE_RECORD_DIVISION]
						== ReferenceResponseDataImpl__LINENO_DATA) {
					// f[^̍s̏ꍇ
					// f[^wb_[ɓWJς݂ł鎖z
					$map = array();

					if (count($this->dataHeader) == (count($lineItem) - 1)) {
						// f[^wb_[ƁAf[^ڐiR[h敪j͈v
						for ($i = 1; $i < count($lineItem); $i++) {
							// Ήf[^wb_[ Key ɁAMap֐ݒ
							$map[$this->dataHeader[$i - 1]] = $lineItem[$i];
						}
					} else {
						// f[^wb_[ƁAf[^ڐvȂꍇ
						$sb = PaygentB2BModuleException__OTHER_ERROR . ": ";
						$sb .= "Not Mutch DataHeaderCount=";
						$sb .= "" . count($this->dataHeader);
						$sb .= " DataItemCount:";
						$sb .= "" . (count($lineItem) - 1);
						trigger_error($sb, E_USER_WARNING);
						return PaygentB2BModuleException__OTHER_ERROR;
					}

					if (0 < count($map)) {
						// Map ݒ肳Ăꍇ
						$this->data[] = $map;
					}
				} else if ($lineItem[ReferenceResponseDataImpl__LINE_RECORD_DIVISION]
						== ReferenceResponseDataImpl__LINENO_TRAILER) {
					// g[[̍s̏ꍇ
					if (ReferenceResponseDataImpl__LINE_TRAILER_DATA_COUNT < count($lineItem)) {
						// f[^TCY
					}
				}
			}
		}

		if (StringUtil::isEmpty($this->resultStatus)) {
			// ʂ 󕶎  null ̏ꍇ
			trigger_error(PaygentB2BModuleConnectException__KS_CONNECT_ERROR
				 . ": resultStatus is Nothing.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
		}
		return true;
	}

	/**
	 * data 𕪉 Uĝ݁Aϐɐݒ
	 * 
	 * @param body
	 * @return mixed TRUE:AFG[R[h 
	 */
	function parseResultOnly($body) {

		$csvTknzr = new CSVTokenizer(CSVTokenizer__DEF_SEPARATOR, 
			CSVTokenizer__DEF_ITEM_ENVELOPE);
		$line = "";

		// ێf[^
		$this->data = array();

		// ݈ʒu
		$this->currentIndex = 0;
		
		// Ug̏
		$this->resultStatus = "";
		$this->responseCode = "";
		$this->responseDetail = "";

		$lines = split(ReferenceResponseDataImpl__LINE_SEPARATOR, $body);
		foreach($lines as $i => $line) {
			$lineItem = $csvTknzr->parseCSVData($line);

			if (0 < count($lineItem)) {
				if ($lineItem[ReferenceResponseDataImpl__LINE_RECORD_DIVISION]
						== ReferenceResponseDataImpl__LINENO_HEADER) {
					// wb_[̍s̏ꍇ
					if (ReferenceResponseDataImpl__LINE_HEADER_RESULT < count($lineItem)) {
						// ʂݒ
						$this->resultStatus = $lineItem[ReferenceResponseDataImpl__LINE_HEADER_RESULT];
					}
					if (ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_CODE < count($lineItem)) {
						// X|XR[hݒ
						$this->responseCode = $lineItem[ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_CODE];
					}
					if (ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_DETAIL < count($lineItem)) {
						// X|Xڍׂݒ
						$this->responseDetail = $lineItem[ReferenceResponseDataImpl__LINE_HEADER_RESPONSE_DETAIL];
					}
				}
			}
		}
		
		if (StringUtil::isEmpty($this->resultStatus)) {
			// ʂ 󕶎  null ̏ꍇ
			trigger_error(PaygentB2BModuleConnectException__KS_CONNECT_ERROR
				. ": resultStatus is Nothing.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
		}
		
		return true;
	}

	/**
	 * ̃f[^擾
	 * 
	 * @return Map
	 */
	function resNext() {
		$map = null;

		if ($this->hasResNext()) {

			$map = $this->data[$this->currentIndex];

			$this->currentIndex++;
		}

		return $map;
	}

	/**
	 * ̃f[^݂邩
	 * 
	 * @return boolean true=݂ false=݂Ȃ
	 */
	function hasResNext() {
		$rb = false;

		if ($this->currentIndex < count($this->data)) {
			$rb = true;
		}

		return $rb;
	}

	/**
	 * resultStatus 擾
	 * 
	 * @return String
	 */
	function getResultStatus() {
		return $this->resultStatus;
	}

	/**
	 * responseCode 擾
	 * 
	 * @return String
	 */
	function getResponseCode() {
		return $this->responseCode;
	}

	/**
	 * responseDetail 擾
	 * 
	 * @return String
	 */
	function getResponseDetail() {
		return $this->responseDetail;
	}

	/**
	 * f[^擾
	 * 
	 * @param data InputStream
	 * @return int -1:G[ 
	 */
	function getDataCount($body) {
		$ri = 0;
		$strCnt = null;
		
		$csvTknzr = new CSVTokenizer(CSVTokenizer__DEF_SEPARATOR, 
			CSVTokenizer__DEF_ITEM_ENVELOPE);
		$line = "";

		$lines = split(ReferenceResponseDataImpl__LINE_SEPARATOR, $body);
		foreach($lines as $i => $line) {
			$lineItem = $csvTknzr->parseCSVData($line);

			if (0 < count($lineItem)) {
				if ($lineItem[ReferenceResponseDataImpl__LINE_RECORD_DIVISION]
						== ReferenceResponseDataImpl__LINENO_TRAILER) {
					// g[[̍s̏ꍇ
					if (ReferenceResponseDataImpl__LINE_TRAILER_DATA_COUNT < count($lineItem)) {
						// f[^擾 while甲
						if (StringUtil::isNumeric($lineItem[ReferenceResponseDataImpl__LINE_TRAILER_DATA_COUNT])) {
							$strCnt = $lineItem[ReferenceResponseDataImpl__LINE_TRAILER_DATA_COUNT];
						}
						break;
					}
				}
			}
		}

		if ($strCnt != null && StringUtil::isNumeric($strCnt)) {
			$ri = intval($strCnt);
		} else {
			return PaygentB2BModuleException__OTHER_ERROR;		//G[
		}

		return $ri;
	}

	/**
	 * CSV 쐬
	 * 
	 * @param resBody
	 * @param resultCsv String
	 * @return boolean trueFAFG[R[h
	 */
	function writeCSV($body, $resultCsv) {
		$rb = false;

		// CSV  1so
		$csvWriter = new CSVWriter($resultCsv);
		if ($csvWriter->open() === false) {
			// t@CI[uG[
			trigger_error(PaygentB2BModuleException__CSV_OUTPUT_ERROR
				. ": Failed to open CSV file.", E_USER_WARNING);
			return PaygentB2BModuleException__CSV_OUTPUT_ERROR;
		}

		$lines = split(ReferenceResponseDataImpl__LINE_SEPARATOR, $body);
		foreach($lines as $i => $line) {
			if (!$csvWriter->writeOneLine($line)) {
				// ߂Ȃꍇ
				trigger_error(PaygentB2BModuleException__CSV_OUTPUT_ERROR
					. ": Failed to write to CSV file.", E_USER_WARNING);
				return PaygentB2BModuleException__CSV_OUTPUT_ERROR;
			}
		}

		$csvWriter->close();

		$rb = true;

		return $rb;
	}

}

?>