<?php
/**
 * PAYGENT B2B MODULE
 * PaygentB2BModule.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

include_once("jp/co/ks/merchanttool/connectmodule/util/HttpsRequestSender.php");
include_once("jp/co/ks/merchanttool/connectmodule/entity/ReferenceResponseDataImpl.php");
include_once("jp/co/ks/merchanttool/connectmodule/entity/ResponseData.php");
include_once("jp/co/ks/merchanttool/connectmodule/util/PaygentB2BModuleLogger.php");
include_once("jp/co/ks/merchanttool/connectmodule/entity/ResponseDataFactory.php");
include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleConnectException.php");
include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleException.php");
include_once("jp/co/ks/merchanttool/connectmodule/util/StringUtil.php");

/**
 * ڑW[ CpNX
 * 
 * @version $Revision: 1.4 $
 * @author $Author: t-mori $
 */


	/**
	 * dp[^ Key Length
	 */
	define("PaygentB2BModule__TELEGRAM_KEY_LENGTH", 30);

	/**
	 * dp[^ Valeu Length
	 */
	define("PaygentB2BModule__TELEGRAM_VALUE_LENGTH", 10240);

	/**
	 * dp[^ ڐ
	 */
	define("PaygentB2BModule__TELEGRAM_ITEM_COUNT", 50);

	/**
	 * ڑID
	 */
	define("PaygentB2BModule__CONNECT_ID_KEY", "connect_id");

	/**
	 * ڑpX[h
	 */
	define("PaygentB2BModule__CONNECT_PASSWORD_KEY", "connect_password");

	/**
	 * dID
	 */
	define("PaygentB2BModule__TELEGRAM_KIND_KEY", "telegram_kind");

	/**
	 * ő匟
	 */
	define("PaygentB2BModule__LIMIT_COUNT_KEY", "limit_count");
	
	/**
	 * ʁF1
	 */
	define("PaygentB2BModule__RESULT_STATUS_ERROR", "1");
	
	/**
	 * X|XR[hF9003
	 */
	define("PaygentB2BModule__RESPONSE_CODE_9003", "9003");


class PaygentB2BModule {
	/**
	 * Jiϊp vd POSTp[^
	 */
	var $REPLACE_KANA_PARAM = array("customer_family_name_kana", "customer_name_kana",
			"payment_detail_kana", "claim_kana", "receipt_name_kana");

	/** NCAgؖt@CpX */
	var $clientFilePath;

	/** CAؖt@CpX */
	var $caFilePath;

	/** ProxyT[o */
	var $proxyServerName;

	/** ProxyIPAhX */
	var $proxyServerIp;

	/** Proxy|[gԍ */
	var $proxyServerPort;

	/** ftHgID */
	var $defaultId;

	/** ftHgpX[h */
	var $defaultPassword;

	/** ^CAEgl */
	var $timeout;

	/** CSVt@C */
	var $resultCsv;

	/** ƉMAX */
	var $selectMaxCnt;

	/** dID */
	var $telegramKind;

	/** PropertiesFile lێ */
	var $masterFile;

	/** ێ */
	var $telegramParam = array();

	/** ʐM */
	var $sender;

	/**  */
	var $responseData;

	/** Logger */
	var $logger = null;

	/**
	 * RXgN^
	 *
	 * @return Ȃ Ă邩̃`FbN 
	 */
	function PaygentB2BModule() {

		// ϐ
		$this->telegramParam = array();

	}
	
	/**
	 * NX
	 * @return mixed true:AFG[R[h
	 */
	function init() {
		// ݒl擾
		$this->masterFile = PaygentB2BModuleResources::getInstance();

		// Logger 擾
		$this->logger = PaygentB2BModuleLogger::getInstance();
		
		if ($this->masterFile == null
			|| strcasecmp(get_class($this->masterFile), "PaygentB2BModuleResources") != 0) {
			// G[R[h
			return $this->masterFile;
		}

		if ($this->logger == null 
			|| strcasecmp(get_class($this->logger), "PaygentB2BModuleLogger") != 0) {
			// G[R[h
			return $this->logger;
		}
		
		// ݒlZbg
		$this->clientFilePath = $this->masterFile->getClientFilePath();
		$this->caFilePath = $this->masterFile->getCaFilePath();
		$this->proxyServerName = $this->masterFile->getProxyServerName();
		$this->proxyServerIp = $this->masterFile->getProxyServerIp();
		$this->proxyServerPort = $this->masterFile->getProxyServerPort();
		$this->defaultId = $this->masterFile->getDefaultId();
		$this->defaultPassword = $this->masterFile->getDefaultPassword();
		$this->timeout = $this->masterFile->getTimeout();
		$this->selectMaxCnt = $this->masterFile->getSelectMaxCnt();

		return true;
	}

	/**
	 * ftHgIDݒ
	 * 
	 * @param defaultId String
	 */
	function setDefaultId($defaultId) {
		$this->defaultId = $defaultId;
	}

	/**
	 * ftHgID擾
	 * 
	 * @return String defaultId
	 */
	function getDefaultId() {
		return $this->defaultId;
	}

	/**
	 * ftHgpX[hݒ
	 * 
	 * @param defaultPassword String
	 */
	function setDefaultPassword($defaultPassword) {
		$this->defaultPassword = $defaultPassword;
	}

	/**
	 * ftHgpX[h擾
	 * 
	 * @return String defaultPassword
	 */
	function getDefaultPassword() {
		return $this->defaultPassword;
	}

	/**
	 * ^CAEglݒ
	 * 
	 * @param timeout int
	 */
	function setTimeout($timeout) {
		$this->timeout = $timeout;
	}

	/**
	 * ^CAEgl擾
	 * 
	 * @return int timeout
	 */
	function getTimeout() {
		return $this->timeout;
	}

	/**
	 * CSVt@Cݒ
	 * 
	 * @param resultCsv String
	 */
	function setResultCsv($resultCsv) {
		$this->resultCsv = $resultCsv;
	}

	/**
	 * CSVt@C擾
	 * 
	 * @return String resultCsv
	 */
	function getResultCsv() {
		return $this->resultCsv;
	}

	/**
	 * ƉMAXݒ
	 * 
	 * @param selectMaxCnt int
	 */
	function setSelectMaxCnt($selectMaxCnt) {
		$this->selectMaxCnt = $selectMaxCnt;
	}

	/**
	 * ƉMAX擾
	 * 
	 * @return String selectMaxCnt
	 */
	function getSelectMaxCnt() {
		return $this->selectMaxCnt;
	}

	/**
	 * ݒ
	 * 
	 * @param key String
	 * @param valuet String
	 */
	function reqPut($key, $value) {
		$tempVal = $value;
		
		if ($tempVal == null) {
			// Value l null ݒ͔F߂Ȃ
			$tempVal = "";
		}
		$this->telegramParam[$key] = $tempVal;
	}

	/**
	 * 擾
	 * 
	 * @param key Stirng
	 * @return String value
	 */
	function reqGet($key) {
		return $this->telegramParam[$key];
	}

	/**
	 * Ɖs
	 * 
	 * @return String trueFA:G[R[hA
	 */
	function post() {

		$rslt = "";
		
		// dID 擾
		$this->telegramKind = "";
		
		if (array_key_exists(PaygentB2BModule__TELEGRAM_KIND_KEY, $this->telegramParam)) {
			$this->telegramKind = $this->telegramParam[PaygentB2BModule__TELEGRAM_KIND_KEY];
		}

		// vdp[^ݒl̐ݒ
		$this->setTelegramParamUnsetting();

		// PostG[`FbN
		$rslt = $this->postErrorCheck();
		if (!($rslt === true)) {
			// G[R[h
			return 	$rslt;
		}

		// URL擾
		$url = $this->masterFile->getUrl($this->telegramKind);
		if ($url === false) {
			return PaygentB2BModuleConnectException__TEREGRAM_PARAM_OUTSIDE_ERROR;
		}

		// HttpsRequestSender擾
		$this->sender = new HttpsRequestSender($url);

		// NCAgؖpXݒ
		$this->sender->setClientCertificatePath($this->clientFilePath);

		// CAؖpXݒ
		$this->sender->setCaCertificatePath($this->caFilePath);

		// ^CAEgݒ
		$this->sender->setTimeout($this->timeout);

		// Proxyڑ^CAEgݒ
		$this->sender->setProxyConnectTimeout($this->timeout);

		// Proxy`^CAEgݒ
		$this->sender->setProxyCommunicateTimeout($this->timeout);

		if ($this->isProxyDataSet()) {
			if (!StringUtil::isEmpty($this->proxyServerIp)) {
				$this->sender->setProxyInfo($this->proxyServerIp, $this->proxyServerPort);
			} else if (!StringUtil::isEmpty($this->proxyServerName)) {
				$this->sender->setProxyInfo($this->proxyServerName, $this->proxyServerPort);
			}
		}

		// Jiϊ
		$this->replaceTelegramKana();

		// d`FbN
		if (!$this->sender->isTelegramLength($this->telegramParam)) {
			// dG[
			return PaygentB2BModuleConnectException__TEREGRAM_PARAM_REQUIRED_ERROR;
		}

		// Post
		$rslt =	$this->sender->postRequestBody($this->telegramParam);
		if (!($rslt === true)) {
			// G[R[h
			return $rslt;
		}

		// Get Response
		$resBody = $this->sender->getResponseBody();

		// Create ResponseData
		$this->responseData = ResponseDataFactory::create($this->telegramKind);

		// Parse Stream
		if ($this->isParseProcess()) {
			$rslt = $this->responseData->parse($resBody);
		} else {
			$rslt = $this->responseData->parseResultOnly($resBody);
		}

		if (!($rslt === true)) {
			return $rslt;
		}

		// CSV Fileo͔
		if ($this->isCSVOutput()) {
			// CSV File o
			if (strcasecmp(get_class($this->responseData), "ReferenceResponseDataImpl") == 0) {
				
				$rslt = $this->responseData->writeCSV($resBody, $this->resultCsv); 
				if (!($rslt === true)) {
					// CSV File Output Error
					return $rslt;
				}
			}
		}
		
		return true;
	}

	/**
	 * ʂԂ
	 * 
	 * @return MapGȂꍇANULL
	 */
	function resNext() {
		if ($this->responseData == null) {
			return null;			
		}
		return $this->responseData->resNext();
	}

	/**
	 * ʂ݂邩
	 * 
	 * @return boolean
	 */
	function hasResNext() {
		if ($this->responseData == null) {
			return false;
		}

		return $this->responseData->hasResNext();
	}

	/**
	 * ʂ擾
	 * 
	 * @return String ʁGȂꍇANULL
	 */
	function getResultStatus() {
		if ($this->responseData == null) {
			return null;
		}
		return $this->responseData->getResultStatus();
	}

	/**
	 * X|XR[h擾
	 * 
	 * @return String X|XR[hGȂꍇANULL
	 */
	function getResponseCode() {
		if ($this->responseData == null) {
			
			return null;
		}
		return $this->responseData->getResponseCode();
	}

	/**
	 * X|Xڍׂ擾
	 * 
	 * @return String X|XڍׁGȂꍇANULL
	 */
	function getResponseDetail() {
		if ($this->responseData == null) {
			return null;
		}
		return $this->responseData->getResponseDetail();
	}

	/**
	 * vdp[^ݒl̐ݒ
	 */
	function setTelegramParamUnsetting() {
		// ڑID
		if (!array_key_exists(PaygentB2BModule__CONNECT_ID_KEY, $this->telegramParam)) {
			// ڑID ݒ̏ꍇAftHgID ݒ
			$this->telegramParam[PaygentB2BModule__CONNECT_ID_KEY] = $this->defaultId;
		}

		// ڑpX[h
		if (!array_key_exists(PaygentB2BModule__CONNECT_PASSWORD_KEY, $this->telegramParam)) {
			// ڑpX[hݒ̏ꍇAftHgpX[h ݒ
			$this->telegramParam[PaygentB2BModule__CONNECT_PASSWORD_KEY] = $this->defaultPassword;
		}

		// ő匟
		if ($this->telegramKind != null) {
			if ($this->masterFile->isTelegramKindRef($this->telegramKind)) {
				// ϏƉ̏ꍇ
				if (!array_key_exists(PaygentB2BModule__LIMIT_COUNT_KEY, $this->telegramParam)) {
					// ő匟ݒ̏ꍇAƉMAXݒ
					$this->telegramParam[PaygentB2BModule__LIMIT_COUNT_KEY] = 
						$this->selectMaxCnt;
				}
			}
		}
	}

	/**
	 * PostG[`FbN
	 * 
	 * @return mixed G[Ȃ̏ꍇFTRUEAFG[R[h
	 */
	function postErrorCheck() {
		// p[^K{`FbN
		if (!$this->isModuleParamCheck()) {
			// W[p[^G[
			trigger_error(PaygentB2BModuleConnectException__MODULE_PARAM_REQUIRED_ERROR 
					. ": Error in indespensable HTTP request value.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__MODULE_PARAM_REQUIRED_ERROR;
		}

		if (!$this->isTeregramParamCheck()) {
			// dvp[^G[
			trigger_error(PaygentB2BModuleConnectException__TEREGRAM_PARAM_OUTSIDE_ERROR 
					. ": HTTP request contains unexpected value.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__TEREGRAM_PARAM_OUTSIDE_ERROR;
		}

		if (!$this->isResultCSV()) {
			// CSVt@CݒG[
			trigger_error(PaygentB2BModuleConnectException__RESPONSE_TYPE_ERROR 
					. ": CVS file name error.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__RESPONSE_TYPE_ERROR;
		}
		
		if (!$this->isTeregramParamKeyNullCheck()) {
			// dvKey null G[
			trigger_error(PaygentB2BModuleConnectException__TEREGRAM_PARAM_REQUIRED_ERROR 
					. ": HTTP request key must be null.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__TEREGRAM_PARAM_REQUIRED_ERROR;
		}

		if (!$this->isTelegramParamKeyLenCheck()) {
			// dvKeyG[
			trigger_error(PaygentB2BModuleConnectException__TEREGRAM_PARAM_REQUIRED_ERROR 
					. ": HTTP request key must be shorter than " 
					. PaygentB2BModule__TELEGRAM_KEY_LENGTH . " bytes.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__TEREGRAM_PARAM_REQUIRED_ERROR;
		}

		if (!$this->isTelegramParamValueLenCheck()) {
			// dvValueG[
			trigger_error(PaygentB2BModuleConnectException__TEREGRAM_PARAM_REQUIRED_ERROR 
					. ": HTTP request value must be shorter than "
					. PaygentB2BModule__TELEGRAM_VALUE_LENGTH . " bytes.", E_USER_WARNING);
			return PaygentB2BModuleConnectException__TEREGRAM_PARAM_REQUIRED_ERROR;
		}

		if (!$this->isTelegramParamItemCountCheck()) {
			// dvڐG[
			trigger_error(PaygentB2BModuleConnectException__TEREGRAM_PARAM_REQUIRED_ERROR 
					. ": The number of HTTP request keys must be smaller than "
					. PaygentB2BModule__TELEGRAM_ITEM_COUNT . ".", E_USER_WARNING);
			return PaygentB2BModuleConnectException__TEREGRAM_PARAM_REQUIRED_ERROR;
		}
		return true;
	}

	/**
	 * W[p[^`FbN
	 * 
	 * @return boolean true=NotError false=Error
	 */
	function isModuleParamCheck() {
		$rb = false;

		// K{G[`FbN
		if ((0 < $this->timeout) && (0 < $this->selectMaxCnt)) {
			$rb = true;
		}

		return $rb;
	}

	/**
	 * dvp[^`FbN
	 * 
	 * @return boolean true=NotError false=Error
	 */
	function isTeregramParamCheck() {
		$rb = false;

		// dID G[`FbN
		if (array_key_exists(PaygentB2BModule__TELEGRAM_KIND_KEY, $this->telegramParam)) {
			if (!StringUtil::isEmpty($this->telegramParam[
				PaygentB2BModule__TELEGRAM_KIND_KEY])) {
				$rb = true;
			}
		}

		return $rb;
	}

	/**
	 * CSVt@Cݒ`FbN
	 * 
	 * @return boolean true=NotError false=Error
	 */
	function isResultCSV() {
		$rb = true;

		// CSVt@CݒG[`FbN
		if (!$this->masterFile->isTelegramKindRef($this->telegramKind)
				&& !StringUtil::isEmpty($this->resultCsv)) {
			$rb = false;
		}

		return $rb;
	}

	/**
	 * dvp[^ Key Null `FbN
	 * 
	 * @return boolean true=NotError false=Error
	 */
	function isTeregramParamKeyNullCheck() {
		$rb = true;

		// Key null `FbN
		if (array_key_exists(null, $this->telegramParam)) {
				$rb = false;
		}

		return $rb;
	}

	/**
	 * dvp[^ Key `FbN
	 * 
	 * @return boolean true=NoError false=Error
	 */
	function isTelegramParamKeyLenCheck() {
		$rb = true;

		foreach($this->telegramParam as $keys => $values) {
			if (!StringUtil::isEmpty($keys)) {
				if (strlen($keys) > PaygentB2BModule__TELEGRAM_KEY_LENGTH) {
					$rb = false;
					break;
				}
			}
		}
		
		return $rb;
	}

	/**
	 * dvp[^ Value `FbN
	 * 
	 * @return boolean true=NoError false=Error
	 */
	function isTelegramParamValueLenCheck() {
		$rb = true;

		foreach($this->telegramParam as $keys => $values) {
			if (!StringUtil::isEmpty($values)) {
				if (strlen($values) > PaygentB2BModule__TELEGRAM_VALUE_LENGTH) {
					$rb = false;
					break;
				}
			}
		}
		
		return $rb;
	}

	/**
	 * dvp[^ ڐ`FbN
	 * 
	 * @return boolean true=NoError false=Error
	 */
	function isTelegramParamItemCountCheck() {
		$rb = false;

		if (count($this->telegramParam) <= PaygentB2BModule__TELEGRAM_ITEM_COUNT) {
			$rb = true;
		}

		return $rb;
	}

	/**
	 * Proxy ݒ蔻
	 * 
	 * @return boolean true=Set false=NotSet
	 */
	function isProxyDataSet() {
		$rb = false;

		if (!(StringUtil::isEmpty($this->proxyServerIp) && StringUtil
				::isEmpty($this->proxyServerName))
				&& 0 < $this->proxyServerPort) {
			// Proxy ݒς̏ꍇ
			$rb = true;
		}

		return $rb;
	}

	/**
	 * Parse 
	 * 
	 * @param InputStream
	 * @return boolean true=parse false=ResultOnly
	 */
	function isParseProcess() {
		$rb = true;

		// Parse {
		if (strcasecmp(get_class($this->responseData), "ReferenceResponseDataImpl") == 0) {
			// ReferenceResponseDataImpl ̏ꍇ̂݁ACSVo͉ۂ{
			if (!StringUtil::isEmpty($this->resultCsv)) {
				$rb = false;
			}
		}

		return $rb;
	}
	
	/**
	 * CSV o͔
	 * 
	 * @return boolean true=CSV Output false=Non
	 */
	function isCSVOutput() {
		$rb = false;

		if ($this->masterFile->isTelegramKindRef($this->telegramKind)
				&& !StringUtil::isEmpty($this->resultCsv)) {
			// dʂƉ  CSVt@C ݒς̏ꍇ
			if ($this->getResultStatus() == PaygentB2BModule__RESULT_STATUS_ERROR) {
				// ʂُ̏ꍇ
				if ($this->getResponseCode() == PaygentB2BModule__RESPONSE_CODE_9003) {
					// X|XR[h 9003 ̏ꍇ
					$rb = true;
				}
			} else {
				// ʂ̏ꍇ
				$rb = true;
			}
		}
		
		return $rb;
	}

	/**
	 * dvp[^ pJi u
	 */
	function replaceTelegramKana() {

		foreach($this->telegramParam as $keys => $values) {
			if (in_array(strtolower($keys), $this->REPLACE_KANA_PARAM)) {
				$this->telegramParam[$keys] = 
					StringUtil::convertKatakanaZenToHan($values);
			}
		}
	}

}

?>
