<?php
/**
 * PAYGENT B2B MODULE
 * CSVTokenizer.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

/**
 * CSVf[^̉̓NXB<BR>
 * Ps̕f[^AڃXgizjɕϊB<BR>
 * ͂̒ɁAf[^ƂĈ͂gpꍇ́A͂2ŁA
 * 1̈͂f[^Ƃ݂ȂB<BR>
 * ͂̒ɑ݂A؂蕶́A؂蕶ƂĂ݂ȂB<BR>
 * ؂蕶̒̕A͂ݕǂň͂ݕ邩ǂ𔻒fB<BR>
 * f[^A؂蕶A͂ȊO̗]vȕ
 * i؂蕶̑ÕXy[XA^uȂǂj݂͂Ƃ߂ȂB
 * @version $Revision: 1.3 $
 * @author $Author: t-mori $
 */


	/** ftHg̍ڋ؂蕶 */
	define("CSVTokenizer__DEF_SEPARATOR", ',');
	/** ftHg̍ڃf[^͂ݕ */
	define("CSVTokenizer__DEF_ITEM_ENVELOPE", '"');
	/** ڃf[^͂ݕ(͂ݎ̂Ȃ) */
	define("CSVTokenizer__NO_ITEM_ENVELOPE", chr(0));

class CSVTokenizer {

	/** ڋ؂蕶 */
	var $separator = null;
	/** ڃf[^͂ݕ */
	var $itemEnvelope = null;

	/** ͑Ώۃf[^ */
	var $line;
	/** ̓ǂݏoJnʒu */
	var $currentPos;
	/** ŏIǍ݈ʒu */
	var $maxPos;

	/**
	 * RXgN^
	 * @param separator ڋ؂蕶
	 * @param envelope ڃf[^͂ݕ
	 */
	function CSVTokenizer($separator = ',', 
		$envelope = '"') {
		$this->separator = $separator;
		$this->itemEnvelope = $envelope;
	}

	/**
	 * CSVf[^񂩂獀ڃf[^z擾B
	 * @param value ͑Ώەi1s̃f[^j
	 * @return        f[^z
	 */
	function parseCSVData($value) {
		if (isset($value) == false) {
			return array();
		}
		$this->line = $value;
		$this->maxPos = strlen($this->line);
		$this->currentPos = 0;

		// ڃf[^i[
		$items = array();
		// ͂ݕ^Ȃ̏ԔtO
		$existEnvelope = false;

		while ($this->currentPos <= $this->maxPos) {
			/* f[^؂ʒu擾 */
			$endPos = $this->getEndPosition($this->currentPos);

			/* Pڕ̃f[^ǂݎ */
			$temp = substr($this->line, $this->currentPos, $endPos - $this->currentPos);
			$work = "";
			// ڃf[^Ȃ̏ꍇ
			if (strlen($temp) == 0) {
				$work = "";
			} else {
				// ͂邩`FbN
				if ($this->itemEnvelope != null
					&& $temp{0} == $this->itemEnvelope) {
					$existEnvelope = true;
				}

				$isData = false;
				for ($i = 0; $i < strlen($temp);) {
					$chrTmp = $temp{$i};
					if ($existEnvelope == true
						&& $temp{$i} == $this->itemEnvelope) {
						$i++;
						if ($isData == true) {
							if (($i < strlen($temp))
								&& ($this->itemEnvelope != null
									&& $temp{$i}
										== $this->itemEnvelope)) {
								/* ͂ݕQČꂽƂ́A
								 * f[^ƂĎ擾 */
								$work .= $temp{$i++};
							} else {
								$isData = !$isData;
							}
						} else {
							$isData = !$isData;
						}
					} else {
						$work .= $temp{$i++};
					}
				}
			}
			/* Pڕ̃f[^o^ */
			$items[] = $work;

			/* ̓ǎʒu̍XV */
			$this->currentPos = $endPos + 1;
		}
		return $items;
	}

	/**
	 *    f[^؂ʒuԂB
	 *    @param        start    Jnʒu
	 *    @return        Pf[^̋؂ʒuԂ
	 */
	function getEndPosition($start) {
		// ^ȌԔtO
		$state = false;
		// ͂ݕ^Ȃ̏ԔtO
		$existEnvelope = false;
		// ǂݍ񂾕
		$ch = null;
		// ؂ʒu
		$end = 0;

		if ($start >= $this->maxPos) {
			return $start;
		}

		// ͂ݕ̗L
		if ($this->itemEnvelope != null
			&& $this->line{$start} == $this->itemEnvelope) {
			$existEnvelope = true;
		}

		$end = $start;

		while ($end < $this->maxPos) {
			// Pǂݍ
			$ch = $this->line{$end};
			// ̔
			if ($state == false
				&& $this->separator != null
				&& $ch == $this->separator) {
				// 񒆂̋؂蕶łȂ΁Af[^؂
				break;
			} else if (
				$existEnvelope == true && $ch == $this->itemEnvelope) {
				// ͂ݕꂽA^ȌԔ𔽓]
				if ($state) {
					$state = false;
				} else {
					$state = true;
				}
			}
			// ʒũJEgAbv
			$end++;
		}
		return $end;
	}

	/**
	 * 񒆂ɃJ}݂ꍇ""ň͂ށB
	 * @param str ϊΏە
	 * @return ϊʕ
	 */
	function cnvKnmString($str) {
		if (isset($str) == false) {
			return null;
		}
		for ($i = 0; $i < strlen($str); ++$i) {
			if ($str{$i} == CSVTokenizer__DEF_SEPARATOR) {

				return "\"" . $str . "\"";
			}
		}

		return $str;
	}
}

?>
