<?php
/**
 * PAYGENT B2B MODULE
 * CSVWriter.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

/**
 * CSVWriter CSV`Ńt@Co͂B
 * gp@F<br />
 * <pre><code>
 * // writerIuWFNgBftHgShift_JISGR[h
 * CSVWriter writer = null;
 * try {
 *     writer = new CSVWriter(
 *         "c:\\temp\\test.txt", CSVWriter.ENCODING_SJIS);
 *     writer.open();
 *     List list = new ArrayList();
 *     list.add("1");
 *     list.add("abc");
 *     list.add("");
 *     list.add(",");
 *     list.add("ɂق");
 *     writer.writeOneLine(list);
 *     list.remove(0);
 *     list.add(0, "2");
 *     writer.writeOneLine(list);
 * } finally {
 *     writer.close();
 * }
 * </code></pre>
 * @version $Revision: 1.4 $
 * @author $Author: t-mori $
 */

	/** t@Co͗pEncoding Shift_JIS */
	define("CSVWriter__ENCODING_SJIS", "Shift_JIS");
	/** t@Co͗pEncoding EUC-JP */
	define("CSVWriter__ENCODING_EUC", "EUC_JP");
	/** t@Co͗pEncoding MS932 */
	define("CSVWriter__ENCODING_MS932", "SJIS-win");	//"Windows-31J";
	    /** t@Cỏ͎sR[h \r\n */
	define("CSVWriter__WINDOWS_NEWLINE", "\r\n");
	    /** t@Cỏ͎sR[h \n */
	define("CSVWriter__UNIX_NEWLINE", "\n");
	    /** t@Cỏ͎sR[h \r */
	define("CSVWriter__MAC_NEWLINE", "\r");

class CSVWriter {

    var $csvFile;
    var $filePath;
    var $encoding;
    var $envelop;
    var $newLine = CSVWriter__WINDOWS_NEWLINE;

    /**
     * RXgN^BGR[hyэڃf[^͂ݕ̎wsWriter쐬B
     * @param filePath t@CpX
     * @param encoding t@C̃GR[h
     * @param envelop ڃf[^͂ݕ
     */
    function CSVWriter($filePath, $encoding = CSVWriter__ENCODING_MS932, $envelop = CSVTokenizer__DEF_ITEM_ENVELOPE) {
        $this->filePath = $filePath;
        $this->encoding = $encoding;
        $this->envelop = $envelop;
    }

    /**
     * o̓t@CJB
     * t@Co͂\ȏԂɂB
      * @return boolean TRUE:AFALSEFs
     */
    function open() {

        $this->csvFile = fopen($this->filePath, "w");
        if ($this->csvFile == false) {
			$this->csvFile = null;
			trigger_error("cannot open file " . $this->filePath . " to write", E_USER_NOTICE);
			return false;        	
        }
        
        // `FbNGR[fBO
        if (mb_convert_encoding("GR[h", $this->encoding) === false){
			trigger_error("Unsupported Encoding " . $this->encoding . ".", E_USER_NOTICE);
			return false;        	
        }
        return true;
    }

    /**
     * o̓t@CB
     * ēxt@C쐬ꍇOpensƁB
     */
    function close() {
        if ($this->csvFile != null) {
            fclose($this->csvFile);
            $this->csvFile = null;
        }
    }

    /**
     * sR[hݒ肷Bݒ̏ꍇA\nŏo͂B
     * @param newLine sR[h̕
     */
    function setNewLine($newLine) {
        $this->newLine = $newLine;
    }

    /**
     * t@CsށBɉsR[hǉB
     * List̏ꍇAList̒gCSV`̈sɕϊAo͂sB
     * @param line s̕(String)͔z(array)
     * @return ߂trueB
     */
    function writeOneLine($line) {

		if (is_string($line)) {
	        if ($this->csvFile == null) {
	            trigger_error("File not open.", E_USER_NOTICE);
	            return false;
	        }
	        $encLine = $line;
		
	        if (fwrite($this->csvFile, $line) === false) {
	        	trigger_error("File can not write.", E_USER_NOTICE);
	            return false;
	        }
	        fwrite($this->csvFile, $this->newLine);
	        flush($this->csvFile);
	        return true;
		} 
		else if (is_array($line)) {
	        $strLine = "";
	
	        // List to CSVString
	        $bFirstLine = true;
	        foreach($line as $i => $data) {
				if ($bFirstLine) {
					$bFirstLine = false;
				} else {
					$strLine .= ",";
				}
	
	            if ($this->envelop != CSVTokenizer__NO_ITEM_ENVELOPE) {
	                $strLine .= $this->envelop;
	            }
	            $strLine .= $this->cnvKnmString($data);
	            if ($this->envelop != CSVTokenizer__NO_ITEM_ENVELOPE) {
	                $strLine .= $this->envelop;
	            }
	        }
	
	        return $this->writeOneLine($strLine);
		}
    }

    /**
     * 񒆂ɃJ}݂ꍇ""ň͂ށB
     * 񒆂Ƀ_uNH[e[V݂ꍇ̓_uNH[e[VŃGXP[vA
     * _uNH[e[Vň͂ށB
     * @param str ϊΏە
     * @return ϊʕ
     */
    function cnvKnmString($str) {
        if ($str == null) {
            return null;
        }
        $flg = false;
        $buf = "";
        for ($i = 0; $i < strlen($str); $i++) {
            if ($str{$i} == $this->envelop) {
                $buf .= $this->envelop;
                $flg = true;
            }
            if ($str{$i} == CSVTokenizer__DEF_SEPARATOR) {
                $flg = true;
            }
            $buf .= $str{$i};
        }
        return $buf;
    }
}

?>