<?php
/**
 * PAYGENT B2B MODULE
 * HttpsRequestSender.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

include_once("jp/co/ks/merchanttool/connectmodule/util/StringUtil.php");
include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleConnectException.php");
include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleException.php");
include_once("jp/co/ks/merchanttool/connectmodule/util/PaygentB2BModuleLogger.php");

/**
 * httpsvȂ[eBeBNXB
 * 
 * @vesrion $Revision: 1.5 $
 * @author $Author: t-mori $
 */
 
	// cURL G[R[h 
	// http://curl.haxx.se/libcurl/c/libcurl-errors.html
	define("HttpsRequestSender__CURLE_COULDNT_CONNECT", 7);
	define("HttpsRequestSender__CURLE_SSL_CERTPROBLEM", 58);	
	define("HttpsRequestSender__CURLE_SSL_CACERT", 60);
	define("HttpsRequestSender__CURLE_SSL_CACERT_BADFILE", 77);
	define("HttpsRequestSender__CURLE_HTTP_RETURNED_ERROR", 22);

	/**
	 * HTTP POST ʐMpŒl
	 */
	define("HttpsRequestSender__POST", "POST");

	/**
	 * HTTPvgR\萔
	 */
	define("HttpsRequestSender__HTTP", "HTTP");

	/**
	 * HTTP/1.0\萔
	 */
	define("HttpsRequestSender__HTTP_1_0", "HTTP/1.0");

	/**
	 * HTTPʐM̐R[h
	 */
	define("HttpsRequestSender__HTTP_1_0_200", "HTTP/1.0 200");
	
	/**
	 * HTTPʐM̐R[hF200
	 */
	define("HttpsRequestSender__HTTP_SUCCESS", 200);
	
	/**
	 * HTTPʐM̐R[hF206
	 */
	define("HttpsRequestSender__HTTP_PARTIAL_CONTENT", 206);

	/**
	 * d
	 */
	define("HttpsRequestSender__TELEGRAM_LENGTH", 10240);

	/**
	 * HTTPS Default Port
	 */
	define("HttpsRequestSender__DEFAULT_PORT", 443);

	/**
	 * NGXgEX|X̉sR[h
	 */
	define("HttpsRequestSender__CRLF", "\r\n");

	/**
	 * ftHg̃GR[fBO
	 */
	define("HttpsRequestSender__DEFAULT_ENCODING", "SJIS-win");

	/**
	 * HTTPXe[^XR[hϐ̏l
	 */
	define("HttpsRequestSender__HTTP_STATUS_INIT_VALUE", -1);

	/**
	 * Xe[^XR[h̒
	 */
	define("HttpsRequestSender__REGEXPSTATUS_LEN", 3);

	/**
	 * Content-Length
	 */
	define("HttpsRequestSender__CONTENT_LENGTH", "Content-Length");

	/**
	 * User-Agent
	 */
	define("HttpsRequestSender__USER_AGENT", "User-Agent");

	/**
	 * Content-Type
	 */
	define("HttpsRequestSender__CONTENT_TYPE", "Content-Type=application/x-www-form-urlencoded");
	define("HttpsRequestSender__HTTP_ENCODING", "charset=Windows-31J");
	
class HttpsRequestSender {
	/**
	 * KeyStore Password
	 */
	var $KEYSTORE_PASSWORD = "changeit";

	/** X|Xwb_ */
	var $responseHeader;

	/** X|X{fB */
	var $responseBody;

	/** Xe[^XR[h@*/
	var $statusCode;
	
	/** ڑ URL */
	var $url;

	/** NCAgؖpX */
	var $clientCertificatePath;

	/** F؋ǏؖpX */
	var $caCertificatePath;

	/** SSLʐMp\Pbg */
	var $ch;

	/** gl\Pbg */
	//var $tunnelSocket;

	/** ^CAEgl int */
	var $timeout;

	/** ProxyzXg */
	var $proxyHostName;

	/** Proxy|[gԍ int */
	var $proxyPort;

	/** Proxyڑ^CAEgl */
	var $proxyConnectTimeout;

	/** Proxy`^CAEgl */
	var $proxyCommunicateTimeout;

	/** Proxygp */
	var $isUsingProxy = false;

	/**
	 * RXgN^<br>
	 * ڑURLݒ
	 * 
	 * @param url String
	 */
	function HttpsRequestSender($url) {
		$this->url = $url;
		$this->proxyHostName = "";
		$this->proxyPort = 0;
		
		$this->responseBody = null;
		$this->responseHeader = null;
	}

	/**
	 * NCAgؖpXݒ
	 * 
	 * @param fileName String
	 */
	function setClientCertificatePath($fileName) {
		$this->clientCertificatePath = $fileName;
	}

	/**
	 * F؋ǏؖpXݒ
	 * 
	 * @param fileName String
	 */
	function setCaCertificatePath($fileName) {
		$this->caCertificatePath = $fileName;
	}

	/**
	 * ^CAEgݒ
	 * 
	 * @param timeout int
	 */
	function setTimeout($timeout) {
		$this->timeout = $timeout;
	}

	/**
	 * Proxyڑ^CAEgݒ
	 * 
	 * @param proxyConnectTimeout int
	 */
	function setProxyConnectTimeout($proxyConnectTimeout) {
		$this->proxyConnectTimeout = $proxyConnectTimeout;
	}

	/**
	 * Proxy`^CAEgݒ
	 * 
	 * @param proxyCommunicateTimeout int
	 */
	function setProxyCommunicateTimeout($proxyCommunicateTimeout) {
		$this->proxyCommunicateTimeout = $proxyCommunicateTimeout;
	}

	/**
	 * ProxyHostName, ProxyPort ݒ
	 * 
	 * @param proxyHostName String
	 * @param proxyPort int
	 */
	function setProxyInfo($proxyHostName, $proxyPort) {
		$this->proxyHostName = $proxyHostName;
		$this->proxyPort = $proxyPort;
		$this->isUsingProxy = false;

		if (!StringUtil::isEmpty($this->proxyHostName) && 0 < $this->proxyPort) {
			// Proxy񂪐ݒ肳ꂽׁAtrue ݒ
			$this->isUsingProxy = true;
		}
	}

	/**
	 * Post{
	 * 
	 * @param formData Map
	 * @return mixed TRUE:A:G[R[h
	 */
	function postRequestBody($formData) {

		// ʐMJn
		$this->initCurl();

		if ($this->isUsingProxy) {
			// vLVoRŒʐMɐڑ
			$this->setProxy();
		}

		// NGXg𑗐M
		$retCode = $this->send($formData);

		// X|XM
		$this->closeCurl();

		return $retCode;
	}

	/**
	 * Mf[^Ԃ
	 * 
	 * @return InputStream
	 */
	function getResponseBody() {
		return $this->responseBody;
	}

	/**
	 * d`FbN
	 * 
	 * @return boolean true=NotError false=Error
	 */
	function isTelegramLength($formData) {
		$rb = false;

		// URL Length Check
		$sb = $this->url;
		$sb .= "?";
		$sb .= $this->convertToUrlEncodedString($formData);

		if (strlen($sb) <= HttpsRequestSender__TELEGRAM_LENGTH) {
			$rb = true;
		}

		return $rb;
	}

	/**
	 * vd쐬
	 * 
	 * @param formData Map vd
	 * @return String 쐬vdiURLj
	 */
	function convertToUrlEncodedString($formData) {
		$encodedString = "";
		if ($formData == null) {
			return "";
		}

		foreach($formData as $key => $value) {
			$this->outputDebugLog("param: " . $key . " = \"" . $value . "\"");
			$tmp = $key;
			$encodedString .= urlencode($tmp);
			$encodedString .= "=";
			$tmp = $value;
			$encodedString .= urlencode($tmp);
			$encodedString .= "&";
		}

		$rs = "";

		if (0 < strlen($encodedString)) {
			$rs = substr($encodedString, 0, strlen($encodedString) - 1);
		}

		return $rs;

	}
	
	/**
	 * fobOOo̓\bh
	 * Oo̓NX̃CX^XɎsWo͂ɃG[bZ[W
	 * o͂B
	 * 
	 * @param msg String o̓bZ[W
	 */
	function outputDebugLog($msg) {
		if(StringUtil::isEmpty($msg)) return;

		$inst = PaygentB2BModuleLogger::getInstance();
		if (is_object($inst)) {
			$inst->debug(get_class($this), $msg);
		}
	}

	/**
	 * Proxyڑp
	 * 
	 */
	function setProxy() {
		curl_setopt($this->ch, CURLOPT_HTTPPROXYTUNNEL, true);
		curl_setopt($this->ch, CURLOPT_PROXY, "http://" . $this->proxyHostName . ":" . $this->proxyPort);

	}

	/**
	 * ڑ̂߂̏
	 * 
	 */
	function initCurl() {
		$rslt = true;
		// 
		$this->ch = curl_init($this->url);

		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0 );
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, true);
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_POST, true);
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_HEADER, true);
		
		// ؖ
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, true);
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_SSL_VERIFYHOST, false);
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_SSLCERT, $this->clientCertificatePath);
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_SSLKEYPASSWD, $this->KEYSTORE_PASSWORD);
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_CAINFO, $this->caCertificatePath);
		
		// ^CAEg
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_TIMEOUT, $this->timeout);
		$rslt = $rslt && curl_setopt($this->ch, CURLOPT_CONNECTTIMEOUT, $this->proxyConnectTimeout);

		return $rslt;
	}

	/**
	 * NGXgƑM
	 * 
	 * @param formData Map vd
	 * @return mixed TRUE:A:G[R[h
	 */
	function send($formData) {
		// NGXg Map  String ɕϊ

		$query = $this->convertToUrlEncodedString($formData);

		$header = array();
		$header[] = HttpsRequestSender__CONTENT_TYPE;
		$header[] = HttpsRequestSender__HTTP_ENCODING;
		$header[] = HttpsRequestSender__CONTENT_LENGTH . ": " 
			. (StringUtil::isEmpty($query)? "0" : strlen($query));
		$header[] = HttpsRequestSender__USER_AGENT . ": " . "curl_php";
		curl_setopt($this->ch, CURLOPT_HTTPHEADER, $header);
		curl_setopt($this->ch, CURLOPT_POSTFIELDS, $query);
		
		$this->outputDebugLog("Query: " . $query);		
		$str = curl_exec($this->ch);

		if ($str === false && curl_errno($this->ch) != 0) {
			return $this->procError($this->ch);
		}
		
		$this->outputDebugLog("Response: " . $str);		
		$data = $str;
		$retCode = $this->parseResponse($data);

		return $retCode;
	}

	/**
	 * Curl̃G[
	 * @return mixed True:ȂAFG[R[h
	 */
	function procError() {
		$errorNo = curl_errno($this->ch);
		$errorMsg = $errorNo . ": " . curl_error($this->ch); 
		$retCode = true;
		
		if ($errorNo <= HttpsRequestSender__CURLE_COULDNT_CONNECT) { // 7
			// ڑ
			$retCode = PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
			$this->outputDebugLog($errorMsg);
		} else if ($errorNo == HttpsRequestSender__CURLE_COULDNT_CONNECT) { // 7
			// ڑ
			$retCode = PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
			$this->outputDebugLog($errorMsg);
		} else if ($errorNo == HttpsRequestSender__CURLE_SSL_CERTPROBLEM) { 
			// Fؖ
			$retCode = PaygentB2BModuleConnectException__CERTIFICATE_ERROR;
			$this->outputDebugLog($errorMsg);
		} else if ($errorNo == HttpsRequestSender__CURLE_SSL_CACERT) {
			// Fؖ
			$retCode = PaygentB2BModuleConnectException__CERTIFICATE_ERROR;
			$this->outputDebugLog($errorMsg);
		} else if ($errorNo == HttpsRequestSender__CURLE_SSL_CACERT_BADFILE) {	// CURLE_SSL_CACERT_BADFILE 
			// Fؖ
			$retCode = PaygentB2BModuleConnectException__CERTIFICATE_ERROR;
			$this->outputDebugLog($errorMsg);
		} else if ($errorNo == HttpsRequestSender__CURLE_HTTP_RETURNED_ERROR) {
			// HTTP Return code error
			$retCode = PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
			$this->outputDebugLog($errorMsg);
		} else {
			// ̑̃G[
			$retCode = PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
			$this->outputDebugLog($errorMsg);
		}

		trigger_error("$retCode: Http request ended with errors.", E_USER_WARNING);
		return $retCode;
	}

	/**
	 * X|XMB
	 * 
	 * @param $data X|X
	 * @return mixed TRUE:A:G[R[h
	 */
	function parseResponse($data) {

		// X|XM
		$line = null;
		$retCode = HttpsRequestSender__HTTP_STATUS_INIT_VALUE;
		$bHeaderOver = false;
		$resBodyStart = 0;
	
		$lines = mb_split(HttpsRequestSender__CRLF, $data);
		// wb_܂łǂݍ
		foreach($lines as $i => $line) {
			
			if (StringUtil::isEmpty($line)) {
				 break;	
			}
			$resBodyStart += strlen($line) + strlen(HttpsRequestSender__CRLF);
			
			if ($retCode === HttpsRequestSender__HTTP_STATUS_INIT_VALUE) {
				// Xe[^X̉
				$retCode = $this->parseStatusLine($line);
				if ($retCode === true) {
					continue;
				}
				$this->outputDebugLog("Cannot get http return code.");
				return $retCode;
			}

			// wb_̉
			if (!$this->parseResponseHeader($line)) {
				continue;
			}
		}
		$resBodyStart += strlen(HttpsRequestSender__CRLF);
		$this->responseBody = substr($data, $resBodyStart);

		return true;
	}

	/**
	 * Xe[^XC
	 * (HTTP-Version SP Status-Code SP Reason-Phrase CRLF)
	 * 
	 * @param line String Xe[^XC
	 * @return mixed TRUE:A:G[R[h
	 */
	function parseStatusLine($line) {

		if (StringUtil::isEmpty($line)) {
				
			// sȃXe[^XR[h󂯎
			return PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
		}

		$statusLine = StringUtil::split($line, " ", 3);

		if (StringUtil::isNumeric($statusLine[1])) {
			$this->statusCode = intVal($statusLine[1]);
		} else {
			
			// sȃXe[^XR[h󂯎
			return PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
		}

		if (strpos($statusLine[0], HttpsRequestSender__HTTP . "/") != 0 
				|| !StringUtil::isNumericLength($statusLine[1], HttpsRequestSender__REGEXPSTATUS_LEN)) {

			// sȃXe[^XR[h󂯎
			return PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
		}
		
		if (!((HttpsRequestSender__HTTP_SUCCESS <= $this->statusCode) 
			&& ($this->statusCode <= HttpsRequestSender__HTTP_PARTIAL_CONTENT))) {

			// HTTP Status  Success Code (200 - 206) łȂꍇ
			return PaygentB2BModuleConnectException__KS_CONNECT_ERROR;
		}

		return true;
	}

	/**
	 * X|Xwb_s͂āAɊi[B<br>
	 * X|Xwb_̒l݂Ȃꍇ́AnullݒB
	 * 
	 * @param line String T[o󂯎X|Xs
	 * @return boolean true=wb_́Ei[, false=wb_ł͂Ȃiwb_Ij
	 */
	function parseResponseHeader($line) {
		if (StringUtil::isEmpty($line)) {
			// HEADERI
			return false;
		}

		// HEADER
		$headerStr = StringUtil::split($line, ":", 2);
		if ($this->responseHeader == null) {
			$this->responseHeader = array();
		}

		if (count($headerStr) == 1 || strlen(trim($headerStr[1])) == 0) {
			// l݂Ȃ or l󕶎
			$this->responseHeader[$headerStr[0]] = null;
		} else {
			$this->responseHeader[$headerStr[0]] = trim($headerStr[1]);
		}

		return true;
	}

	/**
	 * Close curl
	 * 
	 */
	function closeCurl() {
		// vLV\PbgCLOSE
		if ($this->ch != null) {
			curl_close($this->ch);
			$this->ch = null;
		}
	}

}

?>
